var gutter = require('../');
var test = require('tap').test;

var EventEmitter = require('events').EventEmitter;

test('double stream', function (t) {
    t.plan(1);
    
    var e0 = new EventEmitter;
    var i0 = 0;
    var iv0 = setInterval(function () {
        if (++i0 === 5) {
            clearInterval(iv0);
            e0.emit('end');
        }
        else e0.emit('data', i0)
    }, 10);
    
    var e1 = new EventEmitter;
    var i1 = 0;
    var iv1 = setInterval(function () {
        if (++i1 === 3) {
            clearInterval(iv1);
            e1.emit('end');
        }
        else e1.emit('data', i1)
    }, 5);
    
    var s = gutter([
        'foo', e0, 'bar', { baz : e1 }
    ]);
    
    var data = '';
    s.on('data', function (buf) {
        data += buf;
    });
    
    s.on('end', function () {
        t.deepEqual(
            JSON.parse(data),
            [ 'foo', [ 1, 2, 3, 4 ], 'bar', { baz : [ 1, 2 ] } ]
        );
        t.end();
    });
});
